<?php
if($_GET['file'])
{
	define('FPDF_FONTPATH', 'font/');
	require_once "fpdf.php";
    
	// function that sets the style according to what is active
	function setStyle()
    {
    	global $pdf, $bold, $italic, $underline, $blockquote;
        if($bold) $stylestring .= "B";
        if($italic) $stylestring .= "I";
        if($underline) $stylestring .= "U";
		if($blockquote) $pdf->SetLeftMargin(50);
			else $pdf->SetLeftMargin(25);
        $pdf -> SetFont("", $stylestring);
		return $stylestring;
	}
    
    // XML Parsing functions at start of tag
    function startElement($parser, $name, $attrs)
    {
		global $pdf, $bold, $italic, $underline, $blockquote, $align, $TagInfo, $internallink, $currenttag;
        
		// stores last tag for reference
		$currenttag = $name;
		
		if($name == "NEWPAGE") $pdf->AddPage();
		
		if($name == "P" OR $name == "BR")
		{
			$pdf -> Ln();
			if ($name=="P" AND $attrs['ALIGN']) {
				$TagInfo['P'] = $align;
				if(strtoupper($attrs['ALIGN'])=="L" OR strtoupper($attrs['ALIGN'])=="LEFT") 
					$align = "L";
				if(strtoupper($attrs['ALIGN'])=="C" OR strtoupper($attrs['ALIGN'])=="CENTER") 
					$align = "C"; 
				if(strtoupper($attrs['ALIGN'])=="R" OR strtoupper($attrs['ALIGN'])=="RIGHT") 
					$align = "R";
			}
		}
        
		if($name == "DIV")
		{
			if ($name=="DIV" AND $attrs['ALIGN']) {
				$TagInfo['DIV'] = $align;
				if(strtoupper($attrs['ALIGN'])=="L" OR strtoupper($attrs['ALIGN'])=="LEFT") 
					$align = "L";
				if(strtoupper($attrs['ALIGN'])=="C" OR strtoupper($attrs['ALIGN'])=="CENTER") 
					$align = "C"; 
				if(strtoupper($attrs['ALIGN'])=="R" OR strtoupper($attrs['ALIGN'])=="RIGHT") 
					$align = "R";
			}
		}
        
		if($name == "STRONG" OR $name == "B") $bold = true;
        
		if($name == "I" OR $name == "EM") $italic = true;
        
		if($name == "U") $underline = true;
        
		if($name == "FONT")
        {
            if($attrs['SIZE'] == '2') $attrs['SIZE'] = 9;
            if($attrs['SIZE'] == '3') $attrs['SIZE'] = 10;
            if($attrs['SIZE'] == '4') $attrs['SIZE'] = 12;
            if($attrs['SIZE'] == '5') $attrs['SIZE'] = 16;
            if($attrs['SIZE'] == '6') $attrs['SIZE'] = 20;
            if($attrs['SIZE'] == '7') $attrs['SIZE'] = 30;
            if($attrs['SIZE'] == '1') $attrs['SIZE'] = 7;
			else $attrs['SIZE'] = str_replace("pt", "", strtolower($attrs['SIZE']));
			if($attrs['SIZE']) $pdf -> SetFontSize($attrs['SIZE']);
			
			if ($attrs['ALIGN']) $TagInfo['FONT'] = $align;
			if(strtoupper($attrs['ALIGN'])=="L" OR strtoupper($attrs['ALIGN'])=="LEFT") 
				$align = "L";
			if(strtoupper($attrs['ALIGN'])=="C" OR strtoupper($attrs['ALIGN'])=="CENTER") 
				$align = "C"; 
			if(strtoupper($attrs['ALIGN'])=="R" OR strtoupper($attrs['ALIGN'])=="RIGHT") 
				$align = "R";
			
			// if color is set, process and apply color
			if($attrs['COLOR'])
			{
				// set font switch
				$TagInfo['FONTCOLOR'] = true;
				
				// remove hexadecimal pound character if there is one
				$attrs['COLOR'] = ltrim($attrs['COLOR'],"#");
				
				// split hex color code into three parts, convert to DEC, and apply
				
				$pdf->SetTextColor(
					hexdec(substr($attrs['COLOR'],0,2)),
					hexdec(substr($attrs['COLOR'],2,2)),
					hexdec(substr($attrs['COLOR'],4,2))
					);
				
			}
		}
		
		if($name=="A")
		{
			if($attrs['NAME'])
			{ 
				$pdf -> SetLink($internallink[$attrs['NAME']]);
			}
			else if($attrs['HREF'])
			{
				$TagInfo['AHREF'] = $attrs['HREF'];
			}
		}
		
		if($name=="IMG" AND $attrs['SRC'])
		{
			// get image sizes, convert image sizes
			if(!$attrs['WIDTH'] AND !$attrs['HEIGHT'])
			{
				$imagesizes = GetImageSize("htmlfiles/" . $_GET['file'] . "/" . $attrs['SRC']);
				$attrs['WIDTH'] = $imagesizes[0] * .3387;
			}
			else
			{
				$attrs['WIDTH'] = $attrs['WIDTH'] * .3387;
				$attrs['HEIGHT'] = $attrs['HEIGHT'] * .3387;
			}
			
			// get width and height
			if($attrs['WIDTH']==0)
			{
				$attrs['WIDTH'] = $attrs['HEIGHT'] * $imagesizes[0]/$imagesizes[1];
			}
			if($attrs['HEIGHT']==0)
			{
				$attrs['HEIGHT'] = $attrs['WIDTH'] * $imagesizes[1]/$imagesizes[0];
			}
			
			// align image
			if($align == "R"){
				$pdf-> SetX(215.9 - $pdf->rMargin - $attrs['WIDTH']);
			}
			if($align == "C"){
				$pdf-> SetX(107.95 - ($attrs['WIDTH'])/2);
			}
			
			if (substr($TagInfo['AHREF'],0,1) == "#")
			{
				$internalhref = ltrim($TagInfo['AHREF'],"#");
				// render image
				$pdf-> Image("htmlfiles/" . $_GET['file'] . "/" . $attrs['SRC'],$pdf->x,$pdf->y,$attrs['WIDTH'],$attrs['HEIGHT'],'',$internallink[$internalhref]);
			}
			else
			{
				// render image
				$pdf-> Image("htmlfiles/" . $_GET['file'] . "/" . $attrs['SRC'],$pdf->x,$pdf->y,$attrs['WIDTH'],$attrs['HEIGHT'],'',$TagInfo['AHREF']);

			}
			$pdf-> SetXY($pdf->lMargin,$pdf->y + $attrs['HEIGHT']);
		}

		if($name == "BLOCKQUOTE") $blockquote = true;

		if($name == "HR")
		{
			// if aligned left (Write Method), line break before and after HR
			if($align=="L") $pdf-> Ln();
			$pdf -> Line($pdf->lMargin + 10,$pdf->y,215.9 - $pdf->rMargin - 15, $pdf->y);
		}

		if($name == "OL" OR $name == "UL")
		{
			// activate listing
			$TagInfo["LIST"] = $name;
		}

		if($name == "LI")
		{
			if($TagInfo["LIST"])
			{
				$TagInfo["listnumber"]++;
				$pdf -> SetLeftMargin(26);
				if($TagInfo["LIST"] == "OL")
					$pdf -> Write(5,$TagInfo["listnumber"] . ".");
				else if($TagInfo["LIST"] == "UL")
					$pdf -> Rect($pdf->lMargin+4,$pdf->y +2, 1.6,1.6,F);
				$pdf -> SetLeftMargin(34);
			}
		}
	setStyle();
	}
    
    function endElement($parser, $name)
    {
		global $pdf, $bold, $italic, $underline, $blockquote, $align, $currenttag, $internallink, $TagInfo;
    	$currenttag = '';
		if($name == "P")
		{
			if($TagInfo['P'])
			{
				$align = $TagInfo['P'];
				$TagInfo['P'] = false;
			}
			$pdf -> Ln();
		}

		if($name == "DIV")
		{
			if($TagInfo['DIV'])
			{
				$align = $TagInfo['DIV'];
				$TagInfo['DIV'] = false;
			}
		}

        if($name == "STRONG" OR $name == "B") $bold = false;

        if($name == "I" or $name == "EM") $italic = false;

        if($name == "U") $underline = false;

        if($name == "FONT") {
			if($TagInfo['FONT'])
			{
				$align = $TagInfo['FONT'];
				$TagInfo['FONT'] = false;
			}
			
			if($TagInfo['FONTCOLOR'])
			{
				$TagInfo['FONTCOLOR'] = false;
				$pdf->SetTextColor(0,0,0);
			}
			
			$pdf -> SetFontSize(12);
        }

		if($name == "A") $TagInfo['AHREF'] = '';

		if($name == "BLOCKQUOTE") $blockquote = false;

		if($name == "OL" OR $name == "UL")
		{
			// activate listing
			$TagInfo["LIST"] = false;
			$TagInfo["listnumber"] = 0;
			$pdf->Ln();
		}

		if($name == "LI")
		{
			if($TagInfo["LIST"])
			{
				$pdf->ln();
			}
		}
		setStyle();
	}
    
    function charData($parser, $data)
    {
        global $pdf,$underline,$align,$TagInfo,$internallink,$currenttag;
        
		if($currenttag=='A')
		{
			if (substr($TagInfo['AHREF'],0,1) == "#")
			{
				$pdf -> SetTextColor(0,0,255);
				if(!$underline) $pdf-> SetFont('',setStyle()."U");
				$internalhref = ltrim($TagInfo['AHREF'],"#");
				if($align=='L') $pdf -> Write(5,$data,$internallink[$internalhref]);
					else $pdf -> Cell(0,5,$data,0,0,$align,0,$internallink[$internalhref]);
				$pdf->SetTextColor(0);
				setStyle();
			}
			else
			{
				$pdf -> SetTextColor(0,0,255);
				if(!$underline) $pdf-> SetFont('',setStyle()."U");
				if($align=='L') $pdf -> Write(5,$data,$TagInfo['AHREF']);
					else $pdf -> Cell(0,5,$data,0,0,$align,0,$TagInfo['AHREF']);
				$pdf->SetTextColor(0);
				setStyle();
			}
		}
		else 
		{
			if($align=='L') $pdf -> Write(5,$data,'');
				else $pdf -> MultiCell(0,5,$data,0,$align,0);
    	}
	}
	
	// gets HTML file info
    ob_start();
    
    readfile("htmlfiles/" . $_GET['file'] . "/htmlfile.html");
    $htmlfile = ob_get_contents();
    ob_end_clean();
    preg_match_all("/%%([^%]+)%%/", $htmlfile, $linksarray);
    
    // replace links with real links
    $i = 0;
    foreach($linksarray[0] as $link)
    {
		$linkmod = explode('|',str_replace('%%','',$link));
        if($linkmod[1])
		$htmlfile = str_replace($link, "<a href=\"" . $_POST["link" . $i] . "\">" . $linkmod[0] . "</a>", $htmlfile);
		else
		$htmlfile = str_replace($link, $_POST["link" . $i], $htmlfile);

		$i++;
    }
    
    // get title out of HTML file
    preg_match("/<title>(.*)<\/title>/si", $htmlfile, $titletext);
    $pagetitle = $titletext[0];
    
    // strip to only between body tags
    preg_match("/<body[^>]*>(.*)<\/body>/si", $htmlfile, $bodytext);
    
    $htmlfile = $bodytext[0];
	
	$htmlfile = preg_replace("/\r|\n/is","",$htmlfile);
    
    $bold = false;
    $italic = false;
    $underline = false;
	$blockquote = false;
	$align = "L";
	$currenttag = false;
    $internallink = false;
	$TagInfo = array(
	"P" => false,
	"DIV" => false,
	"FONT" => false,
	"AHREF" => false,
	"FONTCOLOR" => false,
	"LIST" => false,
	"listnumber" => 0
	);
    
    
    $parser = xml_parser_create();
    xml_set_element_handler($parser, "startElement", "endElement");
    xml_set_character_data_handler($parser, "charData");
    
	
    // Generate actual PDF
    $pdf = new FPDF("P", "mm", "Letter");
    $pdf -> SetAutoPageBreak(true);
	$pdf -> SetTitle($pagetitle);
	$pdf -> Open();
	

	
	
    // First page
    $pdf -> AddPage();
	

    $pdf -> SetFont('Arial', '', 12);
	$pdf -> SetMargins(25,25,25);
	$pdf -> SetFontSize(12);
	$pdf -> SetFillColor(50,50,50);
	// Index and add all internal links
	preg_match_all("/href=\"#([^><\"]+)\"/i",$htmlfile,$internalLinksArray);
	foreach($internalLinksArray[0] as $anchorname)
	{	
		$anchorname = rtrim($anchorname,"\"");
		$anchorname = str_replace("href=\"#","",$anchorname);
		$internallink[$anchorname] = $pdf -> Addlink();
	}
	
    if(!xml_parse($parser, $htmlfile,true))
	{
		// $pdf -> Write(5,xml_error_string(xml_get_error_code($parser)) . "\n on line" . xml_get_current_line_number($parser));
	}
  
    
    xml_parser_free($parser);
    
	$outputloc = false;
	
	if($_POST['downloadPDFcheckbox'])
		$outputloc = $_GET['file']. ".pdf";
    $pdf -> Output($outputloc,$_POST['downloadPDFcheckbox']);
    
}
else echo "Error - You are not supposed to access this file directly.";
?>